#include <stdio.h>
#include <strings.h>
#include <time.h>
#include <stdlib.h>

#include "All2WEB.h"

#define MINYEAR 1999
#define MAXYEAR 2010

/*
C0 C1 C2 C3 C4 C5 C6 C7  C8 C9 CA CB CC CD CE CF   椥娩
D0 D1 D2 D3 D4 D5 D6 D7  D8 D9 DA DB DC DD DE DF   㦢
E0 E1 E2 E3 E4 E5 E6 E7  E8 E9 EA EB EC ED EE EF   
F0 F1 F2 F3 F4 F5 F6 F7  F8 F9 FA FB FC FD FE FF   
*/

#define KOIMIN   0xc0
#define KOIMAX   0xff
#define KOI2LET  0xDF

unsigned char * strstri(unsigned char *s1, unsigned char *s2)
{
int i;

for(;*s1;s1++)
   {
   for(i=0;(s1[i] && s2[i]);i++)
      if ((s1[i]&KOI2LET) != (s2[i]&KOI2LET))
         break;
   if (!(s2[i]))
      return(s1);
   }
return(NULL);
}

char *a2d(unsigned char *p)
{
int        i;
tm         Time;
unsigned char       *q;
static char buf[20];
static char *months[]={" "," "," "," ",
                " "," "," "," ",
                " "," "," "," "};

for (i=0;p[i];i++)
    if (p[i]<='9' && p[i]>='0')
       {
       unsigned char *endp;

       if ((Time.tm_year=strtol((char *)p+i,(char **)&endp,10))>=MINYEAR && Time.tm_year<=MAXYEAR)
          goto good1;
       i=endp-p;
       }

return(NULL);

good1:
Time.tm_year-=1900;
for (i=0;i<12;i++)
    if ((q=strstri(p,(unsigned char *)months[i]))!=NULL)
       {
       Time.tm_mon=i;
       break;
       }

if (q==NULL)
   return(NULL);

while((q>p) && (*--q==' '));

while((q>=p) && (*(q-1)>='0') && (*(q-1)<='9'))
     q--;

if (((Time.tm_mday=strtol((char *)q,NULL,10))<=0) || (Time.tm_mday>31))
   return(NULL);

strftime(buf,99,"%b_%d_%Y",&Time);
return(buf);
}
